'-------------- Creating Text Report from PC-DMIS -------------------
'
' This script creates text report of the dimensions In the current PP. 
'
' The apperance like text table And look can be modified by person that knows basics of VBA
'
' * Customize the Sub "WriteHeader" In order  To obtain the header you wish
' * The Sub "WriteValues" can be also modified To change the apperance... (changing Italian To the correpsonding language...)
' * "CmdTypeToString1" defines how the keywords will be. If getting a number In your report just add that number
' To the Sub, defining its description
'
' A. Mavrov 2012
'---------------------------------------------------------------------



Option Explicit

Dim App As Object
Dim Part As Object
Dim Parts As Object
Dim Cmds As Object
Dim Cmd As Object
Dim Dcmd As Object
Dim Mypoint As Object
Dim Machine As Object
Dim RefCmd As Object
Dim RefCmd1 As Object

Dim sSelFea(100) As String
Dim iSelFea As Integer

Sub Wait(ByVal T As Integer)
   Dim ts, te, elapsed As Integer
   ts = Timer
   te = Timer
    While elapsed < T
      te = Timer
      elapsed = te - ts
    Wend
End Sub

Function InitPCD() As Boolean

    Dim AllPrg As Integer, i As Integer, onlinei As Integer
    Dim OnLineExists As Boolean
    Dim Response As Integer
    Dim PNactive As String, PNonline As String

    InitPCD = True
    Set App = CreateObject("PCDLRN.Application")
    If App Is Nothing Then
        MsgBox "PC-DMIS initialisation error!", 48, "Error"
        InitPCD = False
    Else

        Set Parts = App.PartPrograms
        AllPrg = Parts.Count
        OnLineExists = False
        For i = 1 To AllPrg
             Set Part = Parts.Item(i)
             Set Machine = Part.ActiveMachine
             If Machine.Name <> "OFFLINE" Then
                OnLineExists = True
                onlinei = i
                PNonline = Part.PartName
                Exit For
             End If
        Next i

        Set Part = App.ActivePartProgram
        If OnLineExists = True Then
           PNactive = Part.PartName
           If PNactive <> PNonline Then
               Response = Part.MessageBox("The following program runs ON-LINE in background: " & Chr(10) & Chr(10) & PNonline & Chr(10) & Chr(10) & "Save statistic for this program?", "EXPORTQS - ON-LINE Program running!", 4)
               If Response = PCDMSG_YES Then
                   Set Part = Parts.Item(onlinei)
               End If
           End If
        End If

        If Part Is Nothing Then
            MsgBox "Part Program not opened!", 48, "Error"
            InitPCD = False
        Else
            Set Cmds = Part.Commands
            If Cmds Is Nothing Then
                MsgBox "Pointer to commands not valid!", 48, "Error"
                InitPCD = False
            End If
        End If
    End If
End Function


Function WriteHeader(Fn As String,  p1 As String, p2 As String, p3 As String, p4 As String, p5 As String, p6 As String, p7 As String, p8 As String, p9 As String, p10 As String, p11 As String, p12 As String, p13 As String, p14 As String, p15 As String, p16 As String, p17 As String, p18 As String, p19 As String, p20 As String) As Integer

    If FileExists(Fn) = True Then
      Open Fn For Append As #1
    Else
      Open Fn For Output As #1
    End If
    Print #1, Fn
    Print #1, ""
    Print #1, "______________________________________________________________________"
    Print #1, "Data            :   " & p1
    Print #1, "Operatore       :   " & p2
    Print #1, "Codice. Art.    :   " & p3
    Print #1, "Rif.to Bolla    :   " & p4
    Print #1, "Nome FRN        :   " & p5
    Print #1, "Pallet          :   " & p6
    Print #1, "Posaggio        :   " & p7
    Print #1, "______________________________________________________________________"
    Print #1, "Commento        :   " & p8
    Print #1, "______________________________________________________________________"
    Print #1, ""
    Print #1, "---------------------------------------------------------------------"
    Print #1, ""
    Close #1

    WriteHeader = 1
End Function

Function RemoveB(ByVal FName As String) As String
    Dim pos As Integer
    RemoveB = FName
    pos = InStr(1, RemoveB, "[", 1)
    If pos <> 0 Then RemoveB = Left(RemoveB, pos - 1)
End Function


Function WriteValues(Fn As String) As Integer
  Dim index As Integer, i As Integer
  Dim tot_com As Integer
  Dim FName As String
  Dim FType As String
  Dim MEA As Double
  Dim UT As Double
  Dim LT As Double
  Dim NOM As Double
  Dim BasPath As String
  Dim ScriptName As String
  Dim BasPathLen As Integer
  Dim RefName As String
  Dim OutputType As String
  Dim AllowOutput As Boolean
  Dim RefName1 As String, RefName2 As String, RefName3 As String

  WriteValues = 0

  Open Fn For Append As #1
  index = 1
  tot_com = Cmds.Count
  For index = 1 To tot_com
     Set Cmd = Cmds.Item(index)
     If Cmd.IsComment Then
        If Left$(Cmd.GetText(COMMENT_TYPE, 0), 1) = "R" Then
              For i = 1 To 100
                 If Len(Cmd.GetText(COMMENT_FIELD, i)) = 0 Then Exit For
                 Print #1, Cmd.GetText(COMMENT_FIELD, i)
              Next i
       End If
     End If

          If Cmd.Type=1001 Or Cmd.Type=1201 Then
                  Print #1, "" 
          End If


     If Cmd.IsDimension And Cmd.Marked = True And Not Cmd.Type = 1299 Then
          If WriteValues <> 2 Then
              WriteValues = 1
          End If
          Set Cmd = Cmds.Item(index)
          Set Dcmd = Cmd.DimensionCommand
          If Len(Dcmd.ID) <> 0 Then
                '----------------------------------
                    FName = lcase(Dcmd.ID)
                    RefName = ""
                    RefName1 = ""
                    RefName2 = ""
                    RefName3 = ""
                    If Dcmd.Feat1 <> "" Then 
                            Set RefCmd1=Cmds.Item(DCmd.Feat1)
                            RefName = "(" & Dcmd.Feat1 & ") (" & CmdTypetostring(RefCmd1.Type) & ") "
                            RefName1=Dcmd.Feat1
                    End If
                    If Dcmd.Feat2 <> "" Then 
                            Set RefCmd=Cmds.Item(DCmd.Feat2)
                            RefName = RefName & "(" & Dcmd.Feat2 & ") (" & CmdTypetostring(RefCmd.Type) & ") "
                            RefName2=Dcmd.Feat2
                    End If
                    If Dcmd.Feat3 <> "" Then 
                            Set RefCmd=Cmds.Item(DCmd.Feat3)
                            RefName = RefName & "(" & Dcmd.Feat3 & ") (" & CmdTypetostring(RefCmd.Type) & ") "
                            RefName3=Dcmd.Feat3
                    End If
                    If RefName <> "" Then RefName = lcase(RefName)
                    If Cmd.Type=1000 Or Cmd.Type=1200 Then
                             FType = CmdTypeToString(RefCmd1.Type)
                    Else
                              FType = CmdTypeToString(Cmd.Type)
                    End If
                    If index <> 1 Then 
                        'Print #1, "" ' Riga separatrice dopo ogni Dimension'
                    End If

                     Print #1, "#    "  & FName & "    " &  Cmd.TypeDescription
                     Print #1, "            MISURATO     TEORICO         DEV    TOL.SUP.    TOL.INF.       FUORI" 
                '----------------------------------
                OutputType = Cmd.GetText(165, 0)
                If UCase(Left(OutputType, 1)) = "N" Then AllowOutput = False Else AllowOutput = True
                ' This is For Single Line Dimension commands
                 If VerifySingleDim(Cmd.Type) And AllowOutput Then
                      UT = Dcmd.Plus
                      LT = Dcmd.Minus
                      LT = LT * (-1)
                      NOM = Dcmd.NOMINAL
                      MEA = Dcmd.MEASURED
                      FType = CmdTypeToString(Cmd.Type)
                      FName = RemoveB(FName)
                      WriteValues = 2

                      Print #1,CmdTypeToString1(Cmd.Type) & Format1(MEA, 4, 12) & Format1(NOM, 4, 12) & Format1(MEA - NOM, 4, 12) & Format1(UT, 4, 12) & Format1(LT, 4, 12) & CalcOOT(NOM, MEA, UT, LT, 4, 12)
                      Print #1, "" 

                 End If
          Else
               ' This is For Multiple Line Dimension commands
                UT = Dcmd.Plus
                LT = Dcmd.Minus
                LT = LT * (-1)
                NOM = Dcmd.NOMINAL
                MEA = Dcmd.MEASURED
                FType = Dcmd.AxisLetter
                If FType = "TP" Then
                        MEA = Dcmd.DEVIATION
                End If
                FName = RemoveB(FName)
                WriteValues = 2
                If AllowOutput Then
                      Select Case Cmd.Type
                      Case 1202
                         Print #1, CmdTypeToString1(Cmd.Type) & Format1(MEA, 4, 12) & Format1(NOM, 4, 12) & Format1(MEA - NOM, 4, 12) 
                      Case 1203
                         Print #1, CmdTypeToString1(Cmd.Type) & Format1(MEA, 4, 12) & Format1(NOM, 4, 12) & Format1(MEA - NOM, 4, 12)
                      Case 1204
                         Print #1, CmdTypeToString1(Cmd.Type) & Format1(MEA, 4, 12) & Format1(NOM, 4, 12) & Format1(MEA - NOM, 4, 12)
                      Case Else
                         Print #1, CmdTypeToString1(Cmd.Type) & Format1(MEA, 4, 12) & Format1(NOM, 4, 12) & Format1(MEA - NOM, 4, 12) & Format1(UT, 4, 12) & Format1(LT, 4, 12) & CalcOOT(NOM, MEA, UT, LT, 4, 12)
                      End Select
                End If
          End If
       End If
       '----- FCF ----
       If Cmd.Type = 184 Then
            FName = Cmd.ID
            RefName = ""
            If Cmd.GetFieldValue(657, 1) <> "" Then RefName = " (" & Cmd.GetFieldValue(657, 1)
            If Cmd.GetFieldValue(657, 2) <> "" Then RefName = RefName & " - " & Cmd.GetFieldValue(657, 2)
            If Cmd.GetFieldValue(657, 3) <> "" Then RefName = RefName & " - " & Cmd.GetFieldValue(657, 3)
            If RefName <> "" Then RefName = RefName & ")"
            MEA = Format(CDbl(Cmd.GetFieldValue(662, 1)), "#####0.0000")
            NOM = Format(CDbl(Cmd.GetFieldValue(687, 1)), "#####0.0000")
            UT = Format(CDbl(Cmd.GetFieldValue(693, 1)), "#####0.0000")
            LT = Format(CDbl(Cmd.GetFieldValue(694, 1)), "#####0.0000")
            LT = LT * (-1)
            FType = Cmd.GetFieldValue(708, 0)
            Print #1, CmdTypeToString2(FType) & Format1(MEA, 4, 12) & Format1(NOM, 4, 12) & Format1(MEA - NOM, 4, 12) & Format1(UT, 4, 12) & Format1(LT, 4, 12) & CalcOOT(NOM, MEA, UT, LT, 4, 12)
       End If
    
    Next index
    
    Print #1, "           --------------------- Fine Controllo -------------------"
    'Print #1, "# DATE=" & Format(Now,"YYYY/MM/DD")
    'Print #1, "# TIME = " & Format(Now,"HH") & ":" & Format(Now,"nn") & ":" & Format(Now,"ss")
        Close #1
End Function

Function VerifySingleDim(dimtype As Integer) As Boolean
    VerifySingleDim = True
    Select Case dimtype
        Case 1000
            VerifySingleDim = False
        Case 1200
            VerifySingleDim = False
    End Select
End Function

Public Function Format1(Number As Double, dcmp As Integer, pos As Integer) As String
    Dim NewLen As Integer, i As Integer
    Dim strformat As String
    strformat = "0."
    For i = 1 To dcmp
        strformat = strformat & "0"
    Next i
    Format1 = Format(Number, strformat)
    NewLen = Len(Format1)
    For i = 1 To pos - NewLen
        Format1 = Chr$(32) & Format1
    Next i
End Function

Private Function CalcOOT(NomV As Double, MeaV As Double, UTV As Double, LTV As Double, dcmp As Integer, pos As Integer) As String
    Dim OOT As Double
    Dim i As Integer
    
    If MeaV < NomV + UTV And MeaV > NomV + LTV Then
        CalcOOT = ""
        For i = 1 To pos
            CalcOOT = CalcOOT & " "
        Next i
        Exit Function
    End If

    If MeaV > NomV + UTV Then OOT = MeaV - (NomV + UTV)
    If MeaV < NomV + LTV Then OOT = MeaV - (NomV + LTV)
    
    CalcOOT = Format1(OOT, dcmp, pos)


End Function

Function CmdTypeToString(ByVal FeatAxis As Integer) As String


            CmdTypeToString = "DIM"
            If FeatAxis = "201" Then FeatAxis = "point"
            If FeatAxis = "202" Then FeatAxis = "circle"
            If FeatAxis = "207" Then FeatAxis = "plane"
            If FeatAxis = "570" Then FeatAxis = "plane" 'Piano Best-Fit 3D'
            If FeatAxis = "602" Then FeatAxis = "point"
            If FeatAxis = "612" Then FeatAxis = "circle"
            If FeatAxis = "617" Then FeatAxis = "plane"
            If FeatAxis = "618" Then FeatAxis = "cparln"
            If FeatAxis = "619" Then FeatAxis = "cparln_q"
            
            If FeatAxis = "1000" Then FeatAxis = "point"
            If FeatAxis = "1106" Then FeatAxis = "distb"
            If FeatAxis = "1107" Then FeatAxis = "distb"
            

        CmdTypeToString = FeatAxis
End Function

Function CmdTypeToString1(ByVal FeatAxis As Integer) As String

          
            

            If FeatAxis = "1002" Then FeatAxis = "X       "
            If FeatAxis = "1003" Then FeatAxis = "Y       "
            If FeatAxis = "1004" Then FeatAxis = "Z       "
            If FeatAxis = "1005" Then FeatAxis = "D       "
            If FeatAxis = "1006" Then FeatAxis = "R       "
            
            If FeatAxis = "1202" Then FeatAxis = "X       "
            If FeatAxis = "1203" Then FeatAxis = "Y       "
            If FeatAxis = "1204" Then FeatAxis = "Z       "
            If FeatAxis = "1205" Then FeatAxis = "D       "
            If FeatAxis = "1206" Then FeatAxis = "R       "
            If FeatAxis = "1209" Then FeatAxis = "TP      "


            If FeatAxis = "1101" Then FeatAxis = "RND     "
            If FeatAxis = "1102" Then FeatAxis = "FLT     "
            If FeatAxis = "1102" Then FeatAxis = "F       "
            If FeatAxis = "1104" Then FeatAxis = "F       "
            If FeatAxis = "1106" Then FeatAxis = "DIST    "
            If FeatAxis = "1107" Then FeatAxis = "DIST    "
            If FeatAxis = "1019" Then FeatAxis = "RND     "
            If FeatAxis = "1118" Then FeatAxis = "PRF     "
            If FeatAxis = "1109" Then FeatAxis = "ANG     "
            If FeatAxis = "1111" Then FeatAxis = "CNC     "
            If FeatAxis = "1114" Then FeatAxis = "COA     "
            If FeatAxis = "1116" Then FeatAxis = "CYLTY   "
            If FeatAxis = "1100" Then FeatAxis = "STR     "
            If FeatAxis = "1110" Then FeatAxis = "RUN     "
            If FeatAxis = "1117" Then FeatAxis = "RUNTOT  "
            If FeatAxis = "1117" Then FeatAxis = "RUN     "
            If FeatAxis = "1105" Then FeatAxis = "SRF     "
            If FeatAxis = "1112" Then FeatAxis = "ANGR    "
            If FeatAxis = "1103" Then FeatAxis = "PER     "
            If FeatAxis = "1104" Then FeatAxis = "PAR     "
            If FeatAxis = "1115" Then FeatAxis = "SYM     "
            If FeatAxis = "1113" Then FeatAxis = "DIM     "
            If FeatAxis = "1009" Then FeatAxis = "PR      "
            If FeatAxis = "1010" Then FeatAxis = "PA      "
            If FeatAxis = "1008" Then FeatAxis = "D       "

            CmdTypeToString1 = FeatAxis
End Function

Function CmdTypeToString2(ByVal FeatAxis As String) As String
            If FeatAxis = "X" Then FeatAxis = "X       "
            If FeatAxis = "Y" Then FeatAxis = "Y       "
            If FeatAxis = "Z" Then FeatAxis = "Z       "
            If FeatAxis = "T" Then FeatAxis = "T       "
            If FeatAxis = "D" Then FeatAxis = "D       "
            If FeatAxis = "L" Then FeatAxis = "L       "
            If FeatAxis = "DF" Then FeatAxis = "DF      "
            If FeatAxis = "TP" Then FeatAxis = "TP      "
            CmdTypeToString2 = FeatAxis
End Function



Function FileExists(Fn As String) As Boolean
        On Error GoTo HandErr:
        Open Fn For Input As #5
        Close #5
        FileExists = True
            Exit Function
HandErr:
        FileExists = False
End Function

Function FindFreeFileName(FN As String)
           Dim i As Double
           Dim FileIndex As Double 
          ' ---> Rimuovere .dmo se inserito nel nome del file 
           If len(FN)>4 Then
               If right(lcase(FN),4)=".txt" Then
                   FN=left(FN,len(FN)-4)
               End If
           End If
           '---> Cercare all'indietro il nome del file, per compilarne il nome libero
	For i=99999 To 1 Step -1
		If FileExists(FN & format(i,"00000") & ".txt")=True Then
                                    FileIndex=i+1
                                    If FileIndex=100000 Then 
                                        MsgBox "Nessun file name libero per : " & FN & " (scrivo su indice 00001!)"
                                        FindFreeFileName = FN & "00001.txt"
                                    Else
			    FindFreeFileName= FN & format(FileIndex,"00000") & ".txt"
                                    End If
                                    Exit Function
                        End If
        Next i 
        '---> Se non hai trovato niente incomincia con 1
        FindFreeFileName= FN & format(1,"00000") & ".txt"  	
End Function

Sub Main(DMOFile As String, p1 As String, p2 As String, p3 As String, p4 As String, p5 As String, p6 As String, p7 As String, p8 As String, p9 As String, p10 As String, p11 As String, p12 As String, p13 As String, p14 As String, p15 As String, p16 As String, p17 As String, p18 As String, p19 As String, p20 As String)
    Dim ExePath As String
    Dim ExeLine As String
    Dim ExeOpt As String
    Dim WriteValueResult As Integer
    Dim Stringa1 As String
    Dim FreeFileName As String
    InitPCD
    FreeFileName = FindFreeFileName(DMOFile)
    If FileExists(FreeFileName) Then Kill FreeFileName
    WriteHeader FreeFileName, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20
    WriteValueResult = WriteValues(FreeFileName)
     
     If WriteValueResult = 0 Then
             MsgBox "Nessuna dimensione trovata!"
      End If
End Sub